-- MySQL dump 10.9
--
-- Host: localhost    Database: automate
-- ------------------------------------------------------
-- Server version	4.1.10a-Debian_2-log

/*!40101 SET @OLD_CHARACTER_SET_CLIENT=@@CHARACTER_SET_CLIENT */;
/*!40101 SET @OLD_CHARACTER_SET_RESULTS=@@CHARACTER_SET_RESULTS */;
/*!40101 SET @OLD_COLLATION_CONNECTION=@@COLLATION_CONNECTION */;
/*!40101 SET NAMES utf8 */;
/*!40014 SET @OLD_UNIQUE_CHECKS=@@UNIQUE_CHECKS, UNIQUE_CHECKS=0 */;
/*!40014 SET @OLD_FOREIGN_KEY_CHECKS=@@FOREIGN_KEY_CHECKS, FOREIGN_KEY_CHECKS=0 */;
/*!40101 SET @OLD_SQL_MODE=@@SQL_MODE, SQL_MODE='NO_AUTO_VALUE_ON_ZERO' */;

--
-- Table structure for table `error`
--

DROP TABLE IF EXISTS `error`;
CREATE TABLE `error` (
  `id` int(11) NOT NULL auto_increment,
  `date` date NOT NULL default '0000-00-00',
  `time` time NOT NULL default '00:00:00',
  `type` varchar(10) NOT NULL default '',
  PRIMARY KEY  (`id`)
) ENGINE=MyISAM DEFAULT CHARSET=latin1 COMMENT='error class';

--
-- Dumping data for table `error`
--


/*!40000 ALTER TABLE `error` DISABLE KEYS */;
LOCK TABLES `error` WRITE;
UNLOCK TABLES;
/*!40000 ALTER TABLE `error` ENABLE KEYS */;

--
-- Table structure for table `log`
--

DROP TABLE IF EXISTS `log`;
CREATE TABLE `log` (
  `id` bigint(20) NOT NULL auto_increment,
  `date` date NOT NULL default '0000-00-00',
  `time` time NOT NULL default '00:00:00',
  `message` varchar(30) NOT NULL default '',
  PRIMARY KEY  (`id`)
) ENGINE=MyISAM DEFAULT CHARSET=latin1;

--
-- Dumping data for table `log`
--


/*!40000 ALTER TABLE `log` DISABLE KEYS */;
LOCK TABLES `log` WRITE;
UNLOCK TABLES;
/*!40000 ALTER TABLE `log` ENABLE KEYS */;

--
-- Table structure for table `login`
--

DROP TABLE IF EXISTS `login`;
CREATE TABLE `login` (
  `id` tinyint(4) NOT NULL auto_increment,
  `nom` varchar(20) NOT NULL default '',
  `pass` varchar(20) NOT NULL default '',
  PRIMARY KEY  (`id`)
) ENGINE=MyISAM DEFAULT CHARSET=latin1;

--
-- Dumping data for table `login`
--


/*!40000 ALTER TABLE `login` DISABLE KEYS */;
LOCK TABLES `login` WRITE;
INSERT INTO `login` VALUES (1,'admin','admin'),(2,'invite','invite');
UNLOCK TABLES;
/*!40000 ALTER TABLE `login` ENABLE KEYS */;

--
-- Table structure for table `osmolation`
--

DROP TABLE IF EXISTS `osmolation`;
CREATE TABLE `osmolation` (
  `id` bigint(20) NOT NULL auto_increment,
  `day` date NOT NULL default '0000-00-00',
  `time` time NOT NULL default '00:00:00',
  `timeend` time NOT NULL default '00:00:00',
  PRIMARY KEY  (`id`)
) ENGINE=MyISAM DEFAULT CHARSET=latin1 COMMENT='osmolation table';

--
-- Dumping data for table `osmolation`
--


/*!40000 ALTER TABLE `osmolation` DISABLE KEYS */;
LOCK TABLES `osmolation` WRITE;
UNLOCK TABLES;
/*!40000 ALTER TABLE `osmolation` ENABLE KEYS */;

--
-- Table structure for table `parametres`
--

DROP TABLE IF EXISTS `parametres`;
CREATE TABLE `parametres` (
  `nom` text NOT NULL,
  `timerdebut` time NOT NULL default '00:00:00',
  `timerfin` time NOT NULL default '00:00:00',
  `button` tinyint(3) unsigned NOT NULL default '0',
  `config` text NOT NULL,
  `nb` tinyint(4) NOT NULL default '0'
) ENGINE=MyISAM DEFAULT CHARSET=latin1 COMMENT='parameters table';

--
-- Dumping data for table `parametres`
--


/*!40000 ALTER TABLE `parametres` DISABLE KEYS */;
LOCK TABLES `parametres` WRITE;
INSERT INTO `parametres` VALUES ('hqi','12:00:00','22:00:00',1,'init',0),('blue','11:00:00','23:00:00',1,'init',0),('pump','08:00:00','20:00:00',1,'init',0),('rah','00:01:00','00:59:00',1,'init',0),('pdoseuse','13:00:00','13:30:00',1,'init',1),('pdoseuse','13:40:00','13:42:00',0,'init',2),('pdoseuse','00:00:00','00:00:00',0,'init',3),('pdoseuse','00:00:00','00:00:00',0,'init',4),('pdoseuse','00:00:00','00:00:00',0,'init',5),('mail','00:00:00','00:00:00',0,'***@***.fr',2),('mail','00:00:00','00:00:00',0,'***@***.fr',1),('mail','00:00:00','00:00:00',0,'***.fr',3),('input','00:00:00','00:00:00',0,'stop_pump',1),('input','00:00:00','00:00:00',0,'stop_skimmer',2),('input','00:00:00','00:00:00',0,'osmolation',3),('input','00:00:00','00:00:00',0,'reserv',4),('input','00:00:00','00:00:00',0,'high',5),('output','00:00:00','00:00:00',0,'hqi',1),('output','00:00:00','00:00:00',0,'blue',2),('output','00:00:00','00:00:00',0,'pump',3),('output','00:00:00','00:00:00',0,'skimmer',4),('output','00:00:00','00:00:00',0,'osmolation',5),('output','00:00:00','00:00:00',0,'temp',6),('output','00:00:00','00:00:00',0,'rah',7),('output','00:00:00','00:00:00',0,'peri',8),('osmolation','00:00:00','00:00:00',0,'',30),('debitosmolation','00:00:00','00:00:00',0,'12.6',0),('starthqi','00:00:00','00:00:00',0,'',20),('start','00:00:00','00:00:00',0,'',0),('thqi','00:00:00','00:00:00',0,'29.5',0),('output','00:00:00','00:00:00',1,'',3),('output','00:00:00','00:00:00',1,'',6);
UNLOCK TABLES;
/*!40000 ALTER TABLE `parametres` ENABLE KEYS */;

--
-- Table structure for table `temperature`
--

DROP TABLE IF EXISTS `temperature`;
CREATE TABLE `temperature` (
  `t` double NOT NULL default '0',
  `nom` char(10) NOT NULL default '',
  `i` int(11) NOT NULL default '0',
  PRIMARY KEY  (`nom`,`i`)
) ENGINE=MyISAM DEFAULT CHARSET=latin1;

--
-- Dumping data for table `temperature`
--


/*!40000 ALTER TABLE `temperature` DISABLE KEYS */;
LOCK TABLES `temperature` WRITE;
INSERT INTO `temperature` VALUES (25,'current',0),(-23,'minmonth',0),(-23,'minmonth',1),(-23,'minmonth',2),(-23,'minmonth',3),(-23,'minmonth',4),(-23,'minmonth',5),(-23,'minmonth',6),(-23,'minmonth',7),(-23,'minmonth',8),(-23,'minmonth',9),(-23,'minmonth',10),(-23,'minmonth',11),(-23,'minmonth',12),(-23,'minmonth',13),(-23,'minmonth',14),(-23,'minmonth',15),(-23,'minmonth',16),(-23,'minmonth',17),(-23,'minmonth',18),(-23,'minmonth',19),(-23,'minmonth',20),(20,'minmonth',21),(20,'minmonth',22),(-23,'minmonth',23),(25,'day',0),(31,'maxmonth',0),(31,'maxmonth',1),(31,'maxmonth',2),(31,'maxmonth',3),(31,'maxmonth',4),(31,'maxmonth',5),(31,'maxmonth',6),(31,'maxmonth',7),(31,'maxmonth',8),(31,'maxmonth',9),(31,'maxmonth',10),(31,'maxmonth',11),(31,'maxmonth',12),(31,'maxmonth',13),(31,'maxmonth',14),(31,'maxmonth',15),(31,'maxmonth',16),(31,'maxmonth',17),(31,'maxmonth',18),(31,'maxmonth',19),(31,'maxmonth',20),(31,'maxmonth',21),(31,'maxmonth',22),(31,'maxmonth',23),(-23,'min',14),(25,'max',14),(25,'day',1),(25,'day',2),(25,'day',3),(25,'day',4),(25,'day',5),(25,'day',6),(25,'day',7),(25,'day',8),(25,'day',9),(-23,'day',10),(-23,'day',11),(-23,'day',12),(-23,'day',13),(-23,'day',14),(-23,'day',15),(-23,'day',16),(25,'day',17),(25,'day',18),(25,'day',19),(25,'day',20),(25,'day',21),(25,'day',22),(25,'day',23),(-23,'min',13),(25,'max',13),(25,'min',22),(25,'max',22),(-23,'min',23),(25,'max',23),(-23,'min',0),(25,'max',0),(-23,'min',1),(25,'max',1),(-23,'min',2),(25,'max',2),(-23,'min',3),(25,'max',3),(-23,'min',4),(25,'max',4),(-23,'min',5),(25,'max',5),(-23,'min',6),(25,'max',6),(-23,'min',7),(25,'max',7),(-23,'min',8),(25,'max',8),(-23,'min',9),(25,'max',9),(-23,'min',10),(-23,'max',10),(-23,'min',11),(-23,'max',11),(-23,'min',12),(-23,'max',12),(-23,'min',15),(-23,'max',15),(-23,'min',16),(-23,'max',16),(-23,'min',17),(25,'max',17),(-23,'min',18),(25,'max',18),(-23,'min',19),(25,'max',19),(-23,'min',20),(25,'max',20),(25,'min',21),(25,'max',21);
UNLOCK TABLES;
/*!40000 ALTER TABLE `temperature` ENABLE KEYS */;

/*!40101 SET SQL_MODE=@OLD_SQL_MODE */;
/*!40014 SET FOREIGN_KEY_CHECKS=@OLD_FOREIGN_KEY_CHECKS */;
/*!40014 SET UNIQUE_CHECKS=@OLD_UNIQUE_CHECKS */;
/*!40101 SET CHARACTER_SET_CLIENT=@OLD_CHARACTER_SET_CLIENT */;
/*!40101 SET CHARACTER_SET_RESULTS=@OLD_CHARACTER_SET_RESULTS */;
/*!40101 SET COLLATION_CONNECTION=@OLD_COLLATION_CONNECTION */;

