#include "util.h"


using namespace mysqlpp;

connexion::connexion( string h,string b, string l, string p) : host(h), base(b), login(l), pass(p) {
mysqlpp::Connection con(true);

}


bool connexion::connect_to_db(){
bool success;

success=con.connect((base.c_str()),(host.c_str()),(login.c_str()), (pass.c_str()));

	if (!success) {
		cout << "Database connection failed." << endl; 
		
	}
	else cout << "Database connection successful\n";

	return success;
}


bool connexion::interroger(){

mysqlpp::Query query = con.query();
query << "select * from parametres";
 
mysqlpp::Result res=query.store();
cout << "nb" << res.size();

Row row;
Result::iterator i;
for (i = res.begin(); i != res.end(); i++) {
row=*i;
cout << row.lookup_by_name("nom") <<"\n";
}

}

void connexion::get_parameter(string nom, param & p,short n)
{
short r;

try{
mysqlpp::Query query = con.query();
query << "select * from parametres where nom='" << nom << "' AND nb='" << n << "'";
mysqlpp::Result res=query.store();


Row row;
Result::iterator i;
i = res.begin(); 
row=*i;
string s(row.lookup_by_name("timerdebut"));
p.set_init_timer(s);
string s2(row.lookup_by_name("timerfin"));
p.set_end_timer(s2);

short b(row.lookup_by_name("button"));
p.set_button(b);

p.set_nb(n);
}

catch (BadQuery& er) {
        // Handle any connection or query errors that may come up
        cerr << "Error: " << er.what() << endl;
            }
    catch (BadConversion& er) {
        // Handle bad conversions
        cerr << "Error: " << er.what() << "\"." << endl
            << "retrieved data size: " << er.retrieved
            << " actual data size: " << er.actual_size << endl;
        
    }
    catch (exception& er) {
        cerr << "Error: " << er.what() << endl;
        
    }
}

//insert into osmolation table
int connexion::insert_osmolation(string time, string end)
{
Query query = con.query();
try
	{
		
		query << "INSERT INTO osmolation (day,time,timeend) VALUES(CURRENT_DATE(),\""<< time <<"\",\"" << end << "\")";
		// execute a query that does not return a result set
		query.execute();
		
		
	}
	catch (BadQuery& er) {
		// handle any connection or query errors that may come up
		cerr << "Error: " << er.what() << endl;
		return -1;
	}
	catch (BadConversion& er) {	
		// handle bad conversions
		cerr << "Error: " << er.what() << "\"." << endl
			<< "retrieved data size: " << er.retrieved
			<< " actual data size: " << er.actual_size << endl;
		return -1;
	}
	catch (exception& er) {
		cerr << "Error: " << er.what() << endl;
		return -1;
	}

return 0;
}

//insert into error table
int connexion::insert_error(short type)
{
Query query = con.query();
try
	{
		
		query << "INSERT INTO error (date,time,type) VALUES(CURRENT_DATE(),CURRENT_TIME(),\"" << type << "\")";

		// execute a query that does not return a result set
		query.execute();
		
		
	}
	catch (BadQuery& er) {
		// handle any connection or query errors that may come up
		cerr << "Error: " << er.what() << endl;
		return -1;
	}
	catch (BadConversion& er) {	
		// handle bad conversions
		cerr << "Error: " << er.what() << "\"." << endl
			<< "retrieved data size: " << er.retrieved
			<< " actual data size: " << er.actual_size << endl;
		return -1;
	}
	catch (exception& er) {
		cerr << "Error: " << er.what() << endl;
		return -1;
	}

return 0;
}

//insert into log table
int connexion::insert_log(string mess)
{
Query query = con.query();
string s;
time_t rawtime;

time ( &rawtime );
s=ctime(&rawtime);

try
	{
		
		query << "INSERT INTO log (date,time,message) VALUES(CURRENT_DATE(),CURRENT_TIME(),\"" << mess << "\")";
		// execute a query that does not return a result set
		query.execute();
		
		
	}
	catch (BadQuery& er) {
		// handle any connection or query errors that may come up
		cerr << "Error: " << er.what() << endl;
		return -1;
	}
	catch (BadConversion& er) {	
		// handle bad conversions
		cerr << "Error: " << er.what() << "\"." << endl
			<< "retrieved data size: " << er.retrieved
			<< " actual data size: " << er.actual_size << endl;
		return -1;
	}
	catch (exception& er) {
		cerr << "Error: " << er.what() << endl;
		return -1;
	}

return 0;
}

//insert into temperature table temperature for a specific hour, compute and store average temp,
int connexion::insert_temperature(double t)
{
double min,max;
int nb;
mysqlpp::Result res;
Row row;
Result::iterator i;


Query query = con.query();
try
	{
		
		query << "REPLACE INTO temperature (t,nom,i) VALUES(\"" << t << "\",\"day\",HOUR(NOW()) )";

		// execute a query that does not return a result set
		query.execute();
		
		
	}
	catch (BadQuery& er) {
		// handle any connection or query errors that may come up
		cerr << "Error: " << er.what() << endl;
		return -1;
	}
	catch (BadConversion& er) {	
		// handle bad conversions
		cerr << "Error: " << er.what() << "\"." << endl
			<< "retrieved data size: " << er.retrieved
			<< " actual data size: " << er.actual_size << endl;
		return -1;
	}
	catch (exception& er) {
		cerr << "Error: " << er.what() << endl;
		return -1;
	}

// compute the min temperature for an hour
try{
//query = con.query();
query << "select * from temperature where nom=\"min\" AND i=HOUR(NOW())";
res=query.store();
if (res.size()==0) 
	{
	min=t;
	}
else
	{
	i = res.begin(); 
	row=*i;
	min= (double)(row.lookup_by_name("t"));
	if (min > t) min=t;
	}


query << "REPLACE INTO temperature (t,nom,i) VALUES(\"" << min << "\",\"min\",HOUR(NOW()) )";

		// execute a query that does not return a result set
		query.execute();
}

catch (BadQuery& er) {
        // Handle any connection or query errors that may come up
        cerr << "Error: " << er.what() << endl;
            }
    catch (BadConversion& er) {
        // Handle bad conversions
        cerr << "Error: " << er.what() << "\"." << endl
            << "retrieved data size: " << er.retrieved
            << " actual data size: " << er.actual_size << endl;
        
    }
    catch (exception& er) {
        cerr << "Error: " << er.what() << endl;
        
    }

// compute the max temperature for an hour
try{
//query = con.query();
query << "select * from temperature where nom=\"max\" AND i=HOUR(NOW())";
res=query.store();
if (res.size()==0) 
	{
	max=t;
	}
else
	{
	i = res.begin(); 
	row=*i;
	max= (double)(row.lookup_by_name("t"));
	if (max < t) max=t;
	}


query << "REPLACE INTO temperature (t,nom,i) VALUES(\"" << max << "\",\"max\",HOUR(NOW()) )";

		// execute a query that does not return a result set
		query.execute();
}

catch (BadQuery& er) {
        // Handle any connection or query errors that may come up
        cerr << "Error: " << er.what() << endl;
            }
    catch (BadConversion& er) {
        // Handle bad conversions
        cerr << "Error: " << er.what() << "\"." << endl
            << "retrieved data size: " << er.retrieved
            << " actual data size: " << er.actual_size << endl;
        
    }
    catch (exception& er) {
        cerr << "Error: " << er.what() << endl;
        
    }

// compute the min temperature of the month for an hour
try{
//query = con.query();
query << "select * from temperature where nom=\"minmonth\" AND i=HOUR(NOW())";
res=query.store();
if (res.size()==0) 
	{
	min=t;
	}
else
	{
	i = res.begin(); 
	row=*i;
	min= (double)(row.lookup_by_name("t"));
	if (min > t) min=t;
	}


query << "REPLACE INTO temperature (t,nom,i) VALUES(\"" << min << "\",\"minmonth\",HOUR(NOW()) )";

		// execute a query that does not return a result set
		query.execute();
}

catch (BadQuery& er) {
        // Handle any connection or query errors that may come up
        cerr << "Error: " << er.what() << endl;
            }
    catch (BadConversion& er) {
        // Handle bad conversions
        cerr << "Error: " << er.what() << "\"." << endl
            << "retrieved data size: " << er.retrieved
            << " actual data size: " << er.actual_size << endl;
        
    }
    catch (exception& er) {
        cerr << "Error: " << er.what() << endl;
        
    }

// compute the max temperature of the month for an hour
try{
//query = con.query();
query << "select * from temperature where nom=\"maxmonth\" AND i=HOUR(NOW())";
res=query.store();
if (res.size()==0) 
	{
	max=t;
	}
else
	{
	i = res.begin(); 
	row=*i;
	max= (double)(row.lookup_by_name("t"));
	if (max < t) max=t;
	}


query << "REPLACE INTO temperature (t,nom,i) VALUES(\"" << max << "\",\"maxmonth\",HOUR(NOW()) )";

		// execute a query that does not return a result set
		query.execute();
}

catch (BadQuery& er) {
        // Handle any connection or query errors that may come up
        cerr << "Error: " << er.what() << endl;
            }
    catch (BadConversion& er) {
        // Handle bad conversions
        cerr << "Error: " << er.what() << "\"." << endl
            << "retrieved data size: " << er.retrieved
            << " actual data size: " << er.actual_size << endl;
        
    }
    catch (exception& er) {
        cerr << "Error: " << er.what() << endl;
        
    }

return 0;
}


//insert into temperature table the current temperature
int connexion::insert_current_temperature(double t)
{
Query query = con.query();
try
	{
		
	query << "REPLACE INTO temperature (t,nom) VALUES(\"" << t << "\",\"current\" )";

		// execute a query that does not return a result set
		query.execute();
		
		
	}
	catch (BadQuery& er) {
		// handle any connection or query errors that may come up
		cerr << "Error: " << er.what() << endl;
		return -1;
	}
	catch (BadConversion& er) {	
		// handle bad conversions
		cerr << "Error: " << er.what() << "\"." << endl
			<< "retrieved data size: " << er.retrieved
			<< " actual data size: " << er.actual_size << endl;
		return -1;
	}
	catch (exception& er) {
		cerr << "Error: " << er.what() << endl;
		return -1;
	}

return 0;
}


// init of output state
int connexion::init_out()
{

mysqlpp::Result res;
Row row;
Result::iterator i;
int j;
Query query = con.query();

for(j=1;j<=8;j++)
{	
try
	{
		
		query << "UPDATE parametres SET button=\"0\"  WHERE nom=\"output\" AND nb=\"" << j << "\"";

		// execute a query that does not return a result set
		query.execute();
				
		
	}
	catch (BadQuery& er) {
		// handle any connection or query errors that may come up
		cerr << "Error: " << er.what() << endl;
		return -1;
	}
	catch (BadConversion& er) {	
		// handle bad conversions
		cerr << "Error: " << er.what() << "\"." << endl
			<< "retrieved data size: " << er.retrieved
			<< " actual data size: " << er.actual_size << endl;
		return -1;
	}
	catch (exception& er) {
		cerr << "Error: " << er.what() << endl;
		return -1;
	}
}

return 0;
}


// maj of output state
int connexion::maj_out(short out,short state)
{

mysqlpp::Result res;
Row row;
Result::iterator i;
short sortie;

sortie=out;
if (out==4) sortie=3;
if (out==8) sortie=4;
if (out==16) sortie=5;
if (out==32) sortie=6;
if (out==64) sortie=7;
if (out==128) sortie=8;
Query query = con.query();
try
	{
		
		query << "UPDATE parametres SET button=\"" << state << "\" WHERE nom=\"output\" AND nb=\"" << sortie << "\"";

		// execute a query that does not return a result set
		query.execute();
		
		
	}
	catch (BadQuery& er) {
		// handle any connection or query errors that may come up
		cerr << "Error: " << er.what() << endl;
		return -1;
	}
	catch (BadConversion& er) {	
		// handle bad conversions
		cerr << "Error: " << er.what() << "\"." << endl
			<< "retrieved data size: " << er.retrieved
			<< " actual data size: " << er.actual_size << endl;
		return -1;
	}
	catch (exception& er) {
		cerr << "Error: " << er.what() << endl;
		return -1;
	}


return 0;
}


//delete log, error of the previous month
int connexion::maj_log()
{
struct tm * timeinfo;
time_t rawtime;
int cm,cd;

time ( &rawtime );
timeinfo = localtime ( &rawtime );
cm=(timeinfo->tm_mon)+1;
cd=(timeinfo->tm_mday);
Query query = con.query();

try
	{
		
		query << "DELETE FROM log WHERE (month(date)< "<< cm << " AND dayofmonth(date) < " << cd << " )";
		// execute a query that does not return a result set
		query.execute();
		query << "DELETE FROM error WHERE (month(date)< "<< cm << " AND dayofmonth(date) < " << cd << " )";
		// execute a query that does not return a result set
		query.execute();
		
	}
	catch (BadQuery& er) {
		// handle any connection or query errors that may come up
		cerr << "Error: " << er.what() << endl;
		return -1;
	}
	catch (BadConversion& er) {	
		// handle bad conversions
		cerr << "Error: " << er.what() << "\"." << endl
			<< "retrieved data size: " << er.retrieved
			<< " actual data size: " << er.actual_size << endl;
		return -1;
	}
	catch (exception& er) {
		cerr << "Error: " << er.what() << endl;
		return -1;
	}

return 0;
}



//maj temperature table => minmonth and maxmonth deleted 
int connexion::maj_temperature()
{
Query query = con.query();

try
	{
		
		query << "DELETE FROM temperature WHERE (nom=\"minmonth\" OR nom=\"maxmonth\" )";
		// execute a query that does not return a result set
		query.execute();
		
		
	}
	catch (BadQuery& er) {
		// handle any connection or query errors that may come up
		cerr << "Error: " << er.what() << endl;
		return -1;
	}
	catch (BadConversion& er) {	
		// handle bad conversions
		cerr << "Error: " << er.what() << "\"." << endl
			<< "retrieved data size: " << er.retrieved
			<< " actual data size: " << er.actual_size << endl;
		return -1;
	}
	catch (exception& er) {
		cerr << "Error: " << er.what() << endl;
		return -1;
	}

return 0;
}

// getting the K8055 config from the database automate
void connexion::get_config(config &cfg)
{
short r,n;
Row row;
Result::iterator i;
mysqlpp::Query query= con.query();
mysqlpp::Result res;
short inp[]= {16,32,1,64,-128};
short out[]={1,2,4,8,16,32,64,128};

try{
query << "select * from parametres where nom='mail' ORDER BY nb";
res=query.store();



for (i = res.begin(); i != res.end(); i++)	
	{
	row=*i;
	n= (int)(row.lookup_by_name("nb"));
	string s(row.lookup_by_name("config"));
	if (n==1) cfg.EXP=s;
	if (n==2) cfg.DEST=s;
	if (n==3) cfg.SMTP=s;
	}
	
}

catch (BadQuery& er) {
        // Handle any connection or query errors that may come up
        cerr << "Error: " << er.what() << endl;
            }
    catch (BadConversion& er) {
        // Handle bad conversions
        cerr << "Error: " << er.what() << "\"." << endl
            << "retrieved data size: " << er.retrieved
            << " actual data size: " << er.actual_size << endl;
        
    }
    catch (exception& er) {
        cerr << "Error: " << er.what() << endl;
        
    }

try{
query << "select * from parametres where nom='input'";
res=query.store();



for (i = res.begin(); i != res.end(); i++)	
	{
	row=*i;
	n= (int)(row.lookup_by_name("nb"));
	string s(row.lookup_by_name("config"));
	if (s=="stop_pump") cfg.STOP_PUMP=inp[n-1] ;
	if (s=="stop_skimmer") cfg.STOP_SKIMMER=inp[n-1] ;
	if (s=="osmolation") cfg.OSMOLATION=inp[n-1] ;
	if (s=="reserv") cfg.RESERV=inp[n-1] ;
	if (s=="high") cfg.HIGH=inp[n-1] ;
	}
	
}

catch (BadQuery& er) {
        // Handle any connection or query errors that may come up
        cerr << "Error: " << er.what() << endl;
            }
    catch (BadConversion& er) {
        // Handle bad conversions
        cerr << "Error: " << er.what() << "\"." << endl
            << "retrieved data size: " << er.retrieved
            << " actual data size: " << er.actual_size << endl;
        
    }
    catch (exception& er) {
        cerr << "Error: " << er.what() << endl;
        
    }

try{
query << "select * from parametres where nom='output'";
res=query.store();



for (i = res.begin(); i != res.end(); i++)	
	{
	row=*i;
	n= (int)(row.lookup_by_name("nb"));
	string s(row.lookup_by_name("config"));
	if (s=="hqi") cfg.OUTHQI=out[n-1] ;
	if (s=="blue") cfg.OUTBLUE=out[n-1] ;
	if (s=="pump") cfg.OUTPUMP=out[n-1] ;
	if (s=="skimmer") cfg.OUTSKIMMER=out[n-1] ;
	if (s=="osmolation") cfg.OUTOSMOLATION=out[n-1] ;
	if (s=="temp") cfg.OUTTEMP=out[n-1] ;
	if (s=="rah") cfg.OUTRAH=out[n-1] ;
	if (s=="peri") cfg.OUTPERI=out[n-1] ;
	}
}

catch (BadQuery& er) {
        // Handle any connection or query errors that may come up
        cerr << "Error: " << er.what() << endl;
            }
    catch (BadConversion& er) {
        // Handle bad conversions
        cerr << "Error: " << er.what() << "\"." << endl
            << "retrieved data size: " << er.retrieved
            << " actual data size: " << er.actual_size << endl;
        
    }
    catch (exception& er) {
        cerr << "Error: " << er.what() << endl;
        
    }

try{
query << "select * from parametres where nom='osmolation'";
res=query.store();
i = res.begin();	
row=*i;
cfg.TOSMOLATION=(int)(row.lookup_by_name("nb"));

}

catch (BadQuery& er) {
        // Handle any connection or query errors that may come up
        cerr << "Error: " << er.what() << endl;
            }
    catch (BadConversion& er) {
        // Handle bad conversions
        cerr << "Error: " << er.what() << "\"." << endl
            << "retrieved data size: " << er.retrieved
            << " actual data size: " << er.actual_size << endl;
        
    }
    catch (exception& er) {
        cerr << "Error: " << er.what() << endl;
        
    }

try{
query << "select nb from parametres where nom='starthqi'";
res=query.store();
i = res.begin();	
row=*i;
cfg.STARTHQI=(double)(row.lookup_by_name("nb"));

}

catch (BadQuery& er) {
        // Handle any connection or query errors that may come up
        cerr << "Error: " << er.what() << endl;
            }
    catch (BadConversion& er) {
        // Handle bad conversions
        cerr << "Error: " << er.what() << "\"." << endl
            << "retrieved data size: " << er.retrieved
            << " actual data size: " << er.actual_size << endl;
        
    }
    catch (exception& er) {
        cerr << "Error: " << er.what() << endl;
        
    }

try{
query << "select config from parametres where nom='thqi'";
res=query.store();
i = res.begin();	
row=*i;
cfg.THQI=(double)(row.lookup_by_name("config"));

}

catch (BadQuery& er) {
        // Handle any connection or query errors that may come up
        cerr << "Error: " << er.what() << endl;
            }
    catch (BadConversion& er) {
        // Handle bad conversions
        cerr << "Error: " << er.what() << "\"." << endl
            << "retrieved data size: " << er.retrieved
            << " actual data size: " << er.actual_size << endl;
        
    }
    catch (exception& er) {
        cerr << "Error: " << er.what() << endl;
        
    }

}

// ckecks if the prog must be restarted
// 0-> no
// 1-> y
// 2-> y with reinit of bd
short connexion::get_start(void)
{
Row row;
Result::iterator i;
mysqlpp::Query query= con.query();
mysqlpp::Result res;
short type;

try{
query << "select nb from parametres where nom='start'";
res=query.store();
i = res.begin();	
row=*i;
type=(int)(row.lookup_by_name("nb"));
return type;

}

catch (BadQuery& er) {
        // Handle any connection or query errors that may come up
        cerr << "Error: " << er.what() << endl;
            }
    catch (BadConversion& er) {
        // Handle bad conversions
        cerr << "Error: " << er.what() << "\"." << endl
            << "retrieved data size: " << er.retrieved
            << " actual data size: " << er.actual_size << endl;
        
    }
    catch (exception& er) {
        cerr << "Error: " << er.what() << endl;
        
    }

}

// set the start attribute to 0 in parametres table used int the starting process

void connexion::set_start(void)
{
mysqlpp::Query query= con.query();

try{
query << "DELETE FROM parametres WHERE (nom=\"start\")";
		// execute a query that does not return a result set
		query.execute();
query << "INSERT INTO parametres (nom,nb) VALUES('start','0')";


		// execute a query that does not return a result set
		query.execute();
	}

catch (BadQuery& er) {
        // Handle any connection or query errors that may come up
        cerr << "Error: " << er.what() << endl;
            }
    catch (BadConversion& er) {
        // Handle bad conversions
        cerr << "Error: " << er.what() << "\"." << endl
            << "retrieved data size: " << er.retrieved
            << " actual data size: " << er.actual_size << endl;
        
    }
    catch (exception& er) {
        cerr << "Error: " << er.what() << endl;
        
    }

}


// set the start attribute to -1 in parametres table

void connexion::set_stop(void)
{
mysqlpp::Query query= con.query();

try{
query << "DELETE FROM parametres WHERE (nom=\"start\")";
		// execute a query that does not return a result set
		query.execute();
query << "INSERT INTO parametres (nom,nb) VALUES('start','-1')";


		// execute a query that does not return a result set
		query.execute();
	}

catch (BadQuery& er) {
        // Handle any connection or query errors that may come up
        cerr << "Error: " << er.what() << endl;
            }
    catch (BadConversion& er) {
        // Handle bad conversions
        cerr << "Error: " << er.what() << "\"." << endl
            << "retrieved data size: " << er.retrieved
            << " actual data size: " << er.actual_size << endl;
        
    }
    catch (exception& er) {
        cerr << "Error: " << er.what() << endl;
        
    }

}


// construct bd
void connexion::construct()
{
cout << "constructing bd" << endl;
system("mysql --exec=\"DROP DATABASE automate;\"");
system("mysql --exec=\"CREATE DATABASE automate;\"");
system("mysql automate < automate.sql");
}

// save bd
void connexion::save()
{
system("mysqldump --opt automate > automate.sql");
}

// close bd
void connexion::close()
{
con.close();
}

